/*
 Copyright(c) 2005 arton.
 
 Permission is granted for use, copying, modification, distribution,
 and distribution of modified versions of this work.
 */
using System;
using System.Drawing;
using System.Diagnostics;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace EverMore
{
	/// <summary>
	/// Page ̊Tv̐łB
	/// </summary>
	public class Page : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Label urlLabel;
		private System.Windows.Forms.Timer idleTimer;
		private System.Windows.Forms.ContextMenu nodeMenu;
		private System.Windows.Forms.MenuItem moveMenuItem;
		private System.Windows.Forms.MenuItem openMenuItem;
		private System.Windows.Forms.MenuItem linkMenuItem;
		private System.Windows.Forms.MenuItem RLinkMenuItem;

		const double D2R = Math.PI / 180;

		public Page(int initDepth, bool showLink)
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
			showLine = showLink;
			depth = initDepth + 1;
			closeHandlers = new ArrayList();
			nodes = new Hashtable();
			colorMap = new Hashtable();
			showLinks = new Hashtable();
			showReverseLinks = new Hashtable();
			generations = new IList[depth];
			positions = new Point[depth][];
			SetStyle(ControlStyles.StandardDoubleClick, true);
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.urlLabel = new System.Windows.Forms.Label();
			this.idleTimer = new System.Windows.Forms.Timer(this.components);
			this.nodeMenu = new System.Windows.Forms.ContextMenu();
			this.moveMenuItem = new System.Windows.Forms.MenuItem();
			this.openMenuItem = new System.Windows.Forms.MenuItem();
			this.linkMenuItem = new System.Windows.Forms.MenuItem();
			this.RLinkMenuItem = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// urlLabel
			// 
			this.urlLabel.AutoSize = true;
			this.urlLabel.BackColor = System.Drawing.Color.White;
			this.urlLabel.Location = new System.Drawing.Point(72, 96);
			this.urlLabel.Name = "urlLabel";
			this.urlLabel.Size = new System.Drawing.Size(34, 15);
			this.urlLabel.TabIndex = 1;
			this.urlLabel.Text = "label1";
			this.urlLabel.MouseUp += new System.Windows.Forms.MouseEventHandler(this.urlLabel_MouseUp);
			// 
			// idleTimer
			// 
			this.idleTimer.Interval = 300;
			this.idleTimer.Tick += new System.EventHandler(this.idleTimer_Tick);
			// 
			// nodeMenu
			// 
			this.nodeMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.openMenuItem,
																					 this.moveMenuItem,
																					 this.linkMenuItem,
																					 this.RLinkMenuItem});
			this.nodeMenu.Popup += new System.EventHandler(this.nodeMenu_Popup);
			// 
			// moveMenuItem
			// 
			this.moveMenuItem.Index = 1;
			this.moveMenuItem.Text = "ړ(&M)";
			this.moveMenuItem.Click += new System.EventHandler(this.moveMenuItem_Click);
			// 
			// openMenuItem
			// 
			this.openMenuItem.Index = 0;
			this.openMenuItem.Text = "J(&O)";
			this.openMenuItem.Click += new System.EventHandler(this.openMenuItem_Click);
			// 
			// linkMenuItem
			// 
			this.linkMenuItem.Index = 2;
			this.linkMenuItem.Text = "N(&L)";
			this.linkMenuItem.Click += new System.EventHandler(this.linkMenuItem_Click);
			// 
			// RLinkMenuItem
			// 
			this.RLinkMenuItem.Index = 3;
			this.RLinkMenuItem.Text = "o[XN(&R)";
			this.RLinkMenuItem.Click += new System.EventHandler(this.RLinkMenuItem_Click);
			// 
			// Page
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(586, 384);
			this.Controls.Add(this.urlLabel);
			this.KeyPreview = true;
			this.Name = "Page";
			this.Text = "Ever More";
			this.Resize += new System.EventHandler(this.Page_Resize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Page_Closing);
			this.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.Page_KeyPress);
			this.Load += new System.EventHandler(this.Page_Load);
			this.DoubleClick += new System.EventHandler(this.Page_DoubleClick);
			this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.Page_MouseUp);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Page_Paint);
			this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.Page_MouseMove);
			this.ResumeLayout(false);

		}
		#endregion

		const int NODE_WIDTH = 5;
		bool showLine;
		Hashtable nodes;
		Hashtable colorMap;
		Hashtable showLinks;
		Hashtable showReverseLinks;
		ArrayList closeHandlers;
		IList[] generations;
		Point[][] positions;
		Point center;
		Size distance;
		Point lastUrlPosition;
		Point lastMousePosition;
		int depth;
		static readonly Color[] genColors = new Color[] {
				Color.Blue,
				Color.BlueViolet,
				Color.Aqua,
				Color.Coral,
				Color.Cyan,
				Color.LightGreen,
				Color.SlateBlue,
				Color.Teal,
														};

		public void AddCloseEventHanlder(EventHandler h)
		{
			closeHandlers.Add(h);
		}

		public void RemoveCloseEventHanlder(EventHandler h)
		{
			closeHandlers.Remove(h);
		}

		public delegate void AddNodeHandler(WebView w, Node n);
		public void AddNode(WebView wv, Node n)
		{
			if (n.Generation == 0)
			{
				Text = n.AbsoluteUri;
			}
			IList list = wv.GetNodes(n.Generation);
			generations[n.Generation] = list;
			positions[n.Generation] = new Point[list.Count];
			RepositionCircle(n.Generation);
			this.Invalidate();
		}

		private void InitSize()
		{
			int hw = (ClientRectangle.Width - NODE_WIDTH) / 2;
			int hh = (ClientRectangle.Height - NODE_WIDTH) / 2;
			center = new Point(hw, hh);
			distance.Width = (ClientRectangle.Width - NODE_WIDTH) / 2 / (depth - 1);
			distance.Height = (ClientRectangle.Height - NODE_WIDTH) / 2 / (depth - 1);
		}

		private void RepositionCircle(int gen)
		{
			if (positions[gen] == null)
			{
				return;
			}
			double hdgbase = 360.0 / positions[gen].Length;
			for (int i = 0; i < positions[gen].Length; i++)
			{
				double dx = Math.Cos(hdgbase * i * D2R) * gen * distance.Width;
				double dy = Math.Sin(hdgbase * i * D2R) * gen * distance.Height;
				positions[gen][i].X = (int)dx;
				positions[gen][i].Y = (int)dy;
				positions[gen][i].Offset(center.X, center.Y);
			}
		}

		private void DrawCircle(Graphics g, int gen)
		{
			Point[] gens = positions[gen];
			if (gens == null)
			{
				return;
			}
			for (int i = 0; i < gens.Length; i++)
			{
				Position(g, gens[i], (Node)generations[gen][i]);
			}
			if (showLine)
			{
				DrawLines(g, gen, false);
			}
		}

		private void ClearCircle(Graphics g, int gen)
		{
			Point[] gens = positions[gen];
			if (gens == null)
			{
				return;
			}
			if (showLine)
			{
				DrawLines(g, gen, true);
			}
			for (int i = 0; i < gens.Length; i++)
			{
				Position(g, gens[i], null);
			}
		}

		/// <summary>
		/// w肳ꂽւ̃N`悷B
		/// </summary>
		/// <param name="g"></param>
		/// <param name="gen"></param>
		/// <param name="clear">Ȃ^</param>
		private void DrawLines(Graphics g, int gen, bool clear)
		{
			if (generations[gen] == null)
			{
				return;
			}
			for (int i = 0; i < generations[gen].Count; i++)
			{
				Pen pen = (clear)? new Pen(BackColor) : new Pen(genColors[gen]);
				Node n = (Node)generations[gen][i];
				Point p = positions[gen][i];
				foreach (Node r in n.GetReveseLinks())
				{
					g.DrawLine(pen, SearchPosition(r), p);
				}
			}
		}

		Point SearchPosition(Node n)
		{
			for (int i = 0; i < generations.Length; i++)
			{
				if (generations[i] == null)
				{
					continue;
				}
				for (int j = 0; j < generations[i].Count; j++)
				{
					if (n == generations[i][j])
					{
						return positions[i][j];
					}
				}
			}
			return new Point(0,0);
		}

		private Rectangle PtoR(Point p)
		{
			p.Offset(- NODE_WIDTH / 2, - NODE_WIDTH / 2);
			return new Rectangle(p, new Size(NODE_WIDTH, NODE_WIDTH));
		}
		
		private void Position(Graphics g, Point p, Node n)
		{
			Color c = (n == null) ? BackColor : GetColor(n);
			using(Brush b = new SolidBrush(c))
			{
				g.FillEllipse(b, PtoR(p));
			}
		}

		private Color GetColor(Node n)
		{
			if (colorMap.ContainsKey(n.Uri.Host))
			{
				return (Color)colorMap[n.Uri.Host];
			}
			int nh = n.Uri.Host.GetHashCode();
			Color c = Color.FromArgb(nh & 0xff, (nh & 0xff00) >> 8, (nh & 0xff0000) >> 16);
			colorMap[n.Uri.Host] = c;
			return c;
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			urlLabel.Visible = false;
			InitSize();
		}

		private void Page_Resize(object sender, System.EventArgs e)
		{
			InitSize();
			for (int i = 0; i < depth; i++)
			{
				RepositionCircle(i);
			}
			Invalidate();
		}

		private void Page_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Graphics g = e.Graphics;
			DrawLinks(g, showLinks);
			DrawLinks(g, showReverseLinks);
			for (int i = 0; i < depth; i++) 
			{
				DrawCircle(g, i);
			}
		}

		private void DrawLinks(Graphics g, Hashtable h)
		{
			foreach (DictionaryEntry ent in h)
			{
				if ((bool)ent.Value)
				{
					if (h.Equals(showLinks))
					{
						DrawLink(g, (Node)ent.Key, false);
					}
					else
					{
						DrawReverseLink(g, (Node)ent.Key, false);
					}
				}
			}
		}

		private Node NodeByPosition(Point p)
		{
			Rectangle rect = PtoR(p);
			for (int i = 0; i < depth; i++)
			{
				if (positions[i] == null)
				{
					continue;
				}
				for (int j = 0; j < positions[i].Length; j++)
				{
					if (rect.Contains(positions[i][j]))
					{
						return (Node)generations[i][j];
					}
				}
			}
			return null;
		}

		private void Page_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Rectangle crect = PtoR(new Point(e.X, e.Y));
			if (DisplayLabelIfNeed(crect))
			{ 
				idleTimer.Enabled = false;
			}
			else
			{
				if (lastUrlPosition.X != -1000)
				{
					Rectangle r = PtoR(lastUrlPosition);
					if (!r.Contains(e.X, e.Y))
					{
						urlLabel.Visible = false;
					}
				}
				lastMousePosition.X = e.X;
				lastMousePosition.Y = e.Y;
				if (NodeByPosition(lastMousePosition) != null)
				{
					idleTimer.Enabled = true;
				}
			}
		}

		private void idleTimer_Tick(object sender, System.EventArgs e)
		{
			idleTimer.Enabled = false;
			Rectangle r = PtoR(Cursor.Position);
			DisplayLabelIfNeed(r);
		}

		private bool DisplayLabelIfNeed(Rectangle crect)
		{
			if (crect.Contains(lastMousePosition))
			{
				Node n = NodeByPosition(lastMousePosition);
				if (n != null)
				{
					urlLabel.Text = n.AbsoluteUri;
					lastUrlPosition = lastMousePosition;
					int x = lastUrlPosition.X;
					if (x + urlLabel.Width > ClientRectangle.Width)
					{
						x = ClientRectangle.Width - urlLabel.Width;
						if (x < 0)
						{
							x = 0;
						}
					}
					int y = lastUrlPosition.Y;
					if (y + urlLabel.Height > ClientRectangle.Height)
					{
						y = ClientRectangle.Height - urlLabel.Height;
					}
					urlLabel.SetBounds(x, y, urlLabel.Width, urlLabel.Height);
					urlLabel.Visible = true;
				}
				return true;
			}
			return false;
		}

		private void Page_DoubleClick(object sender, System.EventArgs e)
		{
			Rectangle r = PtoR(PointToClient(Cursor.Position));
			if (r.Contains(lastMousePosition))
			{
				Node n = NodeByPosition(lastMousePosition);
				if (n != null)
				{
					WebView wv = new WebView(n.Uri, depth - 1, showLine);
				}
			}
		}

		private void urlLabel_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Right)
			{
				nodeMenu.Show(this, PointToClient(Cursor.Position));		
			}
		}

		private void Page_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Right)
			{
				Rectangle r = PtoR(new Point(e.X, e.Y));
				if (r.Contains(lastUrlPosition))
				{
					Node n = NodeByPosition(lastUrlPosition);
					if (n != null)
					{
						nodeMenu.Show(this, PointToClient(Cursor.Position));		
					}
				}
			}
		}

		private void moveMenuItem_Click(object sender, System.EventArgs e)
		{
			Node n = NodeByPosition(lastUrlPosition);
			if (n != null)
			{
				WebView wv = new WebView(n.Uri, depth - 1, showLine);
			}
		}

		private void openMenuItem_Click(object sender, System.EventArgs e)
		{
			Node n = NodeByPosition(lastUrlPosition);
			if (n != null)
			{
				Process.Start(n.AbsoluteUri);
			}
		}

		private void Page_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			EventArgs v = new EventArgs();
			foreach (EventHandler ev in closeHandlers)
			{
				ev(this, v);
			}
		}

		private void linkMenuItem_Click(object sender, System.EventArgs e)
		{
			DrawLinkByMenu((MenuItem)sender, false);
		}

		private void RLinkMenuItem_Click(object sender, System.EventArgs e)
		{
			DrawLinkByMenu((MenuItem)sender, true);
		}

		private void DrawLinkByMenu(MenuItem mi, bool reverse)
		{
			Node n = NodeByPosition(lastUrlPosition);
			if (n != null)
			{
				Graphics g = CreateGraphics();

				if (reverse)
				{
					DrawReverseLink(g, n, mi.Checked);
				}
				else
				{
					DrawLink(g, n, mi.Checked);
				}
				if (reverse)
				{
					showReverseLinks[n] = !mi.Checked;
				}
				else
				{
					showLinks[n] = !mi.Checked;
				}
				mi.Checked = !mi.Checked;
			}
		}

		private void DrawLink(Graphics g, Node n, bool clear)
		{
			Point p = SearchPosition(n);
			using (Pen pen = (clear) ? new Pen(BackColor) : new Pen(genColors[n.Generation + 1]))
			{
				foreach (Node r in n.GetLinks())
				{
					g.DrawLine(pen, SearchPosition(r), p);
				}
			}
		}

		private void DrawReverseLink(Graphics g, Node n, bool clear)
		{
			Point p = SearchPosition(n);
			Pen pen;
			if (clear)
			{
				using (pen = new Pen(BackColor))
				{
					foreach (Node r in n.GetReveseLinks())
					{
						g.DrawLine(pen, SearchPosition(r), p);
					}
				}
			}
			else
			{
				foreach (Node r in n.GetReveseLinks())
				{
					using (pen = new Pen(genColors[r.Generation]))
					{
						g.DrawLine(pen, SearchPosition(r), p);
					}
				}
			}
		}

		private void nodeMenu_Popup(object sender, System.EventArgs e)
		{
			Node n = NodeByPosition(lastUrlPosition);
			if (n != null)
			{
				CheckItem((ContextMenu)sender, n, 2);
				CheckItem((ContextMenu)sender, n, 3);
			}
		}

		private void CheckItem(ContextMenu c, Node n, int index)
		{
			Hashtable h;
			if (index == 2)
			{
				h = showLinks;
			}
			else if (index == 3)
			{
				h = showReverseLinks;
			}
			else
			{
				return;
			}
			bool b = false;
			if (h.ContainsKey(n))
			{
				b = (bool)h[n];
			}
			c.MenuItems[index].Checked = b;
			h[n] = b;
		}

		private void Page_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar == (char)Keys.Escape)
			{
				EventArgs v = new EventArgs();
				foreach (EventHandler ev in closeHandlers)
				{
					ev(this, v);
				}
			}
		}

	}
}
